//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005-2006 Adam Judson
//
//
//  PhotoMap
//  - display user contributed photos in a map
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


// agent to talk to geocoders
// no implementations yet...
function PhotoMapGeocoderAgent(controller) {
   this.init(controller);
}

PhotoMapGeocoderAgent.prototype = {
   init : function(controller) {
      this.controller = controller;
      this.preferences = controller.preferences;
   },

   geocode : function(callback, location) {
      // probably shouldn't send the transaction here...
      var geocodeTxn = this.createTransaction(location);
      geocodeTxn.callback = callback;
      geocodeTxn.send();
   },

   doneGeocode : function(txn, wasError) {
      if (!wasError) {
         var location = txn.getLocation();
         txn.callback.execute(location, wasError);
      }
   },

   createTransaction : function(location) {
      var type = this.preferences.getGeocoderType();
      if (type == "geocoder.ca") {
         return new GeocoderCATransaction(new Callback(this, this.doneGeocode), location);
      } else if (type == "yahoo") {
         return new YahooGeocoderTransaction(new Callback(this, this.doneGeocode), location);
      }
      throw "Bad Geocoder type";
   }
};
